Index: doc/papers/ibm_CASCON19/ThreadingModels.fig
===================================================================
--- doc/papers/ibm_CASCON19/ThreadingModels.fig	(revision 487198cf171252d74e2d10d1290d95f53163b810)
+++ doc/papers/ibm_CASCON19/ThreadingModels.fig	(revision 487198cf171252d74e2d10d1290d95f53163b810)
@@ -0,0 +1,140 @@
+#FIG 3.2  Produced by xfig version 3.2.5b
+Landscape
+Center
+Inches
+Letter  
+100.00
+Single
+-2
+1200 2
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 2700 3300 150 150 2700 3300 2850 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 3150 3300 150 150 3150 3300 3300 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 4050 3300 150 150 4050 3300 4200 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 4500 3300 150 150 4500 3300 4650 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 4950 3300 150 150 4950 3300 5100 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 5400 3300 150 150 5400 3300 5550 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 5850 3300 150 150 5850 3300 6000 3300
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 3600 3300 150 150 3600 3300 3750 3300
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 6450 3150 100 100 6450 3150 6550 3150
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 1800 2175 150 150 1800 2175 1950 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 3000 2175 150 150 3000 2175 3150 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 3450 2175 150 150 3450 2175 3600 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 3900 2175 150 150 3900 2175 4050 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 5100 2175 150 150 5100 2175 5250 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 6300 2175 150 150 6300 2175 6450 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 6750 2175 150 150 6750 2175 6900 2175
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 7200 2175 150 150 7200 2175 7350 2175
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 1800 2175 100 100 1800 2175 1900 2175
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 3000 2175 100 100 3000 2175 3100 2175
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 3450 2175 100 100 3450 2175 3550 2175
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 3900 2175 100 100 3900 2175 4000 2175
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 4650 1425 100 100 4650 1425 4750 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 4950 1425 100 100 4950 1425 5050 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 5250 1425 100 100 5250 1425 5350 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 5550 1425 100 100 5550 1425 5650 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 6300 1425 100 100 6300 1425 6400 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 6600 1425 100 100 6600 1425 6700 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 6900 1425 100 100 6900 1425 7000 1425
+1 3 0 1 0 7 50 -1 15 0.000 1 0.0000 7200 1425 100 100 7200 1425 7300 1425
+1 3 0 1 0 7 50 -1 -1 0.000 1 0.0000 6450 3600 150 150 6450 3600 6600 3600
+1 3 1 1 0 7 50 -1 -1 4.000 1 0.0000 6450 3600 100 100 6450 3600 6550 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 1800 2175 2700 3300
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3000 2175 3150 3300
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3450 2175 3600 3300
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3900 2175 4050 3300
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4500 3300 5100 2175
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4950 3300 6300 2175
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5400 3300 6750 2175
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5850 3300 7200 2175
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 2775 3450 3825 3675
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3225 3450 3900 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3675 3450 4050 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4125 3450 4200 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4500 3450 4350 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4950 3450 4500 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5400 3450 4650 3600
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5850 3450 4725 3675
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3825 3750 3375 3900
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4200 3750 3975 3900
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4350 3750 4575 3900
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4650 3750 5175 3900
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 3225 3900 3525 3900 3525 4200 3225 4200 3225 3900
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 3825 3900 4125 3900 4125 4200 3825 4200 3825 3900
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 4425 3900 4725 3900 4725 4200 4425 4200 4425 3900
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 5025 3900 5325 3900 5325 4200 5025 4200 5025 3900
+2 2 0 2 4 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 2400 3000 6150 3000 6150 4350 2400 4350 2400 3000
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 6300 3975 6600 3975 6600 4275 6300 4275 6300 3975
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4950 1500 5100 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5250 1500 5100 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 4650 1500 4875 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5550 1500 5325 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5100 1800 5100 2025
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6600 1500 6750 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6900 1500 6750 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6300 1500 6525 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 7200 1500 6975 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6750 1800 6750 2025
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 4500 1275 5700 1275 5700 2400 4500 2400 4500 1275
+2 2 0 2 4 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 6000 1275 7500 1275 7500 2400 6000 2400 6000 1275
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 2700 1275 4200 1275 4200 2400 2700 2400 2700 1275
+2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 1200 1275 2400 1275 2400 2400 1200 2400 1200 1275
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6600 1800 6300 2025
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 6900 1800 7200 2025
+4 1 0 50 -1 0 12 0.0000 2 135 435 1800 2775 1:1:4\001
+4 1 0 50 -1 0 12 0.0000 2 135 435 3450 2775 3:3:4\001
+4 1 0 50 -1 0 12 0.0000 2 135 435 5100 2775 4:1:4\001
+4 1 0 50 -1 0 12 0.0000 2 135 435 6750 2775 4:3:4\001
+4 2 0 50 -1 0 12 0.0000 2 180 585 2250 3975 System\001
+4 2 0 50 -1 0 12 0.0000 2 180 810 2250 3750 Operating\001
+4 1 0 50 -1 0 12 0.0000 2 135 780 4275 3750 scheduler\001
+4 0 0 50 -1 0 12 0.0000 2 135 885 6750 3225 user thread\001
+4 0 0 50 -1 0 12 0.0000 2 135 1065 6750 3675 kernel thread\001
+4 0 0 50 -1 0 12 0.0000 2 135 375 6750 4200 CPU\001
+4 1 0 50 -1 0 12 0.0000 2 180 1020 1800 1200 Process$_1$\001
+4 1 0 50 -1 0 12 0.0000 2 180 1020 3450 1200 Process$_2$\001
+4 1 0 50 -1 0 12 0.0000 2 180 1020 5100 1200 Process$_3$\001
+4 1 0 50 -1 0 12 0.0000 2 180 1020 6750 1200 Process$_4$\001
+4 1 0 50 -1 0 11 0.0000 2 120 675 5100 1800 scheduler\001
+4 1 0 50 -1 0 11 0.0000 2 120 675 6750 1800 scheduler\001